Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision )
@@ -2890,807 +1312,521 @@
         $yytos->stateno = $yyNewState;
         $yytos->major = $yyMajor;
         $yytos->minor = $yypMinor;
-        array_push($this->yystack, $yytos);
+        $this->yystack[] = $yytos;
         if ($this->yyTraceFILE && $this->yyidx > 0) {
-            fprintf($this->yyTraceFILE, "%sShift %d\n", $this->yyTracePrompt,
-                    $yyNewState);
+            fprintf($this->yyTraceFILE, "%sShift %d\n", $this->yyTracePrompt, $yyNewState);
             fprintf($this->yyTraceFILE, "%sStack:", $this->yyTracePrompt);
             for ($i = 1; $i <= $this->yyidx; $i ++) {
-                fprintf($this->yyTraceFILE, " %s",
-                        $this->yyTokenName[$this->yystack[$i]->major]);
+                fprintf($this->yyTraceFILE, " %s", $this->yyTokenName[ $this->yystack[ $i ]->major ]);
             }
             fwrite($this->yyTraceFILE, "\n");
         }
     }
 
-    public static $yyRuleInfo = array(
-        array('lhs' => 83, 'rhs' => 1),
-        array('lhs' => 84, 'rhs' => 1),
-        array('lhs' => 84, 'rhs' => 2),
-        array('lhs' => 84, 'rhs' => 0),
-        array('lhs' => 85, 'rhs' => 2),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 85, 'rhs' => 1),
-        array('lhs' => 87, 'rhs' => 2),
-        array('lhs' => 87, 'rhs' => 3),
-        array('lhs' => 88, 'rhs' => 2),
-        array('lhs' => 88, 'rhs' => 0),
-        array('lhs' => 89, 'rhs' => 1),
-        array('lhs' => 89, 'rhs' => 1),
-        array('lhs' => 86, 'rhs' => 2),
-        array('lhs' => 86, 'rhs' => 4),
-        array('lhs' => 86, 'rhs' => 3),
-        array('lhs' => 86, 'rhs' => 4),
-        array('lhs' => 86, 'rhs' => 3),
-        array('lhs' => 86, 'rhs' => 5),
-        array('lhs' => 86, 'rhs' => 5),
-        array('lhs' => 86, 'rhs' => 6),
-        array('lhs' => 86, 'rhs' => 5),
-        array('lhs' => 86, 'rhs' => 3),
-        array('lhs' => 86, 'rhs' => 2),
-        array('lhs' => 86, 'rhs' => 5),
-        array('lhs' => 86, 'rhs' => 4),
-        array('lhs' => 86, 'rhs' => 6),
-        array('lhs' => 86, 'rhs' => 2),
-        array('lhs' => 86, 'rhs' => 3),
-        array('lhs' => 86, 'rhs' => 2),
-        array('lhs' => 86, 'rhs' => 3),
-        array('lhs' => 86, 'rhs' => 11),
-        array('lhs' => 99, 'rhs' => 2),
-        array('lhs' => 99, 'rhs' => 1),
-        array('lhs' => 86, 'rhs' => 5),
-        array('lhs' => 86, 'rhs' => 7),
-        array('lhs' => 86, 'rhs' => 2),
-        array('lhs' => 86, 'rhs' => 7),
-        array('lhs' => 86, 'rhs' => 10),
-        array('lhs' => 86, 'rhs' => 7),
-        array('lhs' => 86, 'rhs' => 10),
-        array('lhs' => 86, 'rhs' => 3),
-        array('lhs' => 86, 'rhs' => 4),
-        array('lhs' => 86, 'rhs' => 2),
-        array('lhs' => 86, 'rhs' => 2),
-        array('lhs' => 86, 'rhs' => 3),
-        array('lhs' => 86, 'rhs' => 4),
-        array('lhs' => 86, 'rhs' => 5),
-        array('lhs' => 92, 'rhs' => 2),
-        array('lhs' => 92, 'rhs' => 1),
-        array('lhs' => 92, 'rhs' => 0),
-        array('lhs' => 101, 'rhs' => 4),
-        array('lhs' => 101, 'rhs' => 2),
-        array('lhs' => 101, 'rhs' => 2),
-        array('lhs' => 101, 'rhs' => 2),
-        array('lhs' => 101, 'rhs' => 2),
-        array('lhs' => 101, 'rhs' => 2),
-        array('lhs' => 101, 'rhs' => 4),
-        array('lhs' => 96, 'rhs' => 1),
-        array('lhs' => 96, 'rhs' => 3),
-        array('lhs' => 95, 'rhs' => 4),
-        array('lhs' => 95, 'rhs' => 3),
-        array('lhs' => 95, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 1),
-        array('lhs' => 93, 'rhs' => 1),
-        array('lhs' => 93, 'rhs' => 4),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 1),
-        array('lhs' => 93, 'rhs' => 2),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 2),
-        array('lhs' => 93, 'rhs' => 2),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 2),
-        array('lhs' => 93, 'rhs' => 2),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 93, 'rhs' => 3),
-        array('lhs' => 102, 'rhs' => 8),
-        array('lhs' => 102, 'rhs' => 7),
-        array('lhs' => 90, 'rhs' => 1),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 90, 'rhs' => 1),
-        array('lhs' => 90, 'rhs' => 1),
-        array('lhs' => 90, 'rhs' => 3),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 90, 'rhs' => 1),
-        array('lhs' => 90, 'rhs' => 1),
-        array('lhs' => 90, 'rhs' => 3),
-        array('lhs' => 90, 'rhs' => 1),
-        array('lhs' => 90, 'rhs' => 1),
-        array('lhs' => 90, 'rhs' => 3),
-        array('lhs' => 90, 'rhs' => 3),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 90, 'rhs' => 2),
-        array('lhs' => 106, 'rhs' => 1),
-        array('lhs' => 106, 'rhs' => 4),
-        array('lhs' => 106, 'rhs' => 1),
-        array('lhs' => 106, 'rhs' => 3),
-        array('lhs' => 106, 'rhs' => 4),
-        array('lhs' => 106, 'rhs' => 3),
-        array('lhs' => 106, 'rhs' => 4),
-        array('lhs' => 94, 'rhs' => 3),
-        array('lhs' => 111, 'rhs' => 2),
-        array('lhs' => 111, 'rhs' => 0),
-        array('lhs' => 112, 'rhs' => 3),
-        array('lhs' => 112, 'rhs' => 5),
-        array('lhs' => 112, 'rhs' => 2),
-        array('lhs' => 112, 'rhs' => 2),
-        array('lhs' => 112, 'rhs' => 4),
-        array('lhs' => 112, 'rhs' => 3),
-        array('lhs' => 112, 'rhs' => 5),
-        array('lhs' => 112, 'rhs' => 3),
-        array('lhs' => 112, 'rhs' => 2),
-        array('lhs' => 98, 'rhs' => 1),
-        array('lhs' => 98, 'rhs' => 2),
-        array('lhs' => 113, 'rhs' => 1),
-        array('lhs' => 113, 'rhs' => 3),
-        array('lhs' => 110, 'rhs' => 2),
-        array('lhs' => 114, 'rhs' => 1),
-        array('lhs' => 114, 'rhs' => 2),
-        array('lhs' => 115, 'rhs' => 3),
-        array('lhs' => 115, 'rhs' => 4),
-        array('lhs' => 115, 'rhs' => 5),
-        array('lhs' => 115, 'rhs' => 6),
-        array('lhs' => 115, 'rhs' => 2),
-        array('lhs' => 107, 'rhs' => 4),
-        array('lhs' => 116, 'rhs' => 4),
-        array('lhs' => 116, 'rhs' => 5),
-        array('lhs' => 117, 'rhs' => 3),
-        array('lhs' => 117, 'rhs' => 1),
-        array('lhs' => 117, 'rhs' => 0),
-        array('lhs' => 91, 'rhs' => 3),
-        array('lhs' => 91, 'rhs' => 2),
-        array('lhs' => 118, 'rhs' => 3),
-        array('lhs' => 118, 'rhs' => 2),
-        array('lhs' => 100, 'rhs' => 2),
-        array('lhs' => 100, 'rhs' => 0),
-        array('lhs' => 119, 'rhs' => 2),
-        array('lhs' => 119, 'rhs' => 2),
-        array('lhs' => 109, 'rhs' => 1),
-        array('lhs' => 109, 'rhs' => 2),
-        array('lhs' => 109, 'rhs' => 1),
-        array('lhs' => 109, 'rhs' => 3),
-        array('lhs' => 109, 'rhs' => 4),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 104, 'rhs' => 1),
-        array('lhs' => 105, 'rhs' => 1),
-        array('lhs' => 105, 'rhs' => 1),
-        array('lhs' => 105, 'rhs' => 1),
-        array('lhs' => 103, 'rhs' => 3),
-        array('lhs' => 120, 'rhs' => 1),
-        array('lhs' => 120, 'rhs' => 3),
-        array('lhs' => 120, 'rhs' => 0),
-        array('lhs' => 121, 'rhs' => 3),
-        array('lhs' => 121, 'rhs' => 3),
-        array('lhs' => 121, 'rhs' => 1),
-        array('lhs' => 108, 'rhs' => 2),
-        array('lhs' => 108, 'rhs' => 3),
-        array('lhs' => 122, 'rhs' => 2),
-        array('lhs' => 122, 'rhs' => 1),
-        array('lhs' => 123, 'rhs' => 3),
-        array('lhs' => 123, 'rhs' => 3),
-        array('lhs' => 123, 'rhs' => 1),
-        array('lhs' => 123, 'rhs' => 3),
-        array('lhs' => 123, 'rhs' => 3),
-        array('lhs' => 123, 'rhs' => 2),
-        array('lhs' => 123, 'rhs' => 1),
-        array('lhs' => 97, 'rhs' => 1),
-        array('lhs' => 97, 'rhs' => 0),
-    );
+    public static $yyRuleInfo = array(array(0 => 61, 1 => 1), array(0 => 62, 1 => 1), array(0 => 62, 1 => 2),
+                                      array(0 => 62, 1 => 0), array(0 => 63, 1 => 1), array(0 => 63, 1 => 1),
+                                      array(0 => 63, 1 => 1), array(0 => 63, 1 => 1), array(0 => 63, 1 => 1),
+                                      array(0 => 66, 1 => 1), array(0 => 66, 1 => 2), array(0 => 63, 1 => 1),
+                                      array(0 => 63, 1 => 1), array(0 => 65, 1 => 2), array(0 => 65, 1 => 3),
+                                      array(0 => 67, 1 => 2), array(0 => 67, 1 => 0), array(0 => 68, 1 => 1),
+                                      array(0 => 68, 1 => 1), array(0 => 64, 1 => 2), array(0 => 64, 1 => 1),
+                                      array(0 => 69, 1 => 2), array(0 => 69, 1 => 3), array(0 => 69, 1 => 2),
+                                      array(0 => 69, 1 => 3), array(0 => 69, 1 => 2), array(0 => 69, 1 => 3),
+                                      array(0 => 69, 1 => 4), array(0 => 69, 1 => 4), array(0 => 69, 1 => 5),
+                                      array(0 => 69, 1 => 5), array(0 => 64, 1 => 1), array(0 => 69, 1 => 3),
+                                      array(0 => 69, 1 => 2), array(0 => 69, 1 => 4), array(0 => 69, 1 => 5),
+                                      array(0 => 69, 1 => 6), array(0 => 69, 1 => 2), array(0 => 69, 1 => 3),
+                                      array(0 => 69, 1 => 2), array(0 => 69, 1 => 3), array(0 => 69, 1 => 8),
+                                      array(0 => 78, 1 => 2), array(0 => 78, 1 => 1), array(0 => 69, 1 => 5),
+                                      array(0 => 69, 1 => 7), array(0 => 69, 1 => 2), array(0 => 69, 1 => 6),
+                                      array(0 => 69, 1 => 8), array(0 => 69, 1 => 6), array(0 => 69, 1 => 8),
+                                      array(0 => 69, 1 => 3), array(0 => 69, 1 => 4), array(0 => 69, 1 => 2),
+                                      array(0 => 64, 1 => 1), array(0 => 69, 1 => 2), array(0 => 69, 1 => 3),
+                                      array(0 => 69, 1 => 4), array(0 => 69, 1 => 5), array(0 => 71, 1 => 2),
+                                      array(0 => 71, 1 => 1), array(0 => 71, 1 => 0), array(0 => 81, 1 => 4),
+                                      array(0 => 81, 1 => 2), array(0 => 81, 1 => 2), array(0 => 81, 1 => 2),
+                                      array(0 => 81, 1 => 2), array(0 => 81, 1 => 2), array(0 => 81, 1 => 4),
+                                      array(0 => 77, 1 => 1), array(0 => 77, 1 => 3), array(0 => 76, 1 => 3),
+                                      array(0 => 76, 1 => 3), array(0 => 76, 1 => 3), array(0 => 76, 1 => 3),
+                                      array(0 => 73, 1 => 1), array(0 => 73, 1 => 1), array(0 => 73, 1 => 3),
+                                      array(0 => 73, 1 => 3), array(0 => 73, 1 => 3), array(0 => 73, 1 => 1),
+                                      array(0 => 73, 1 => 2), array(0 => 73, 1 => 3), array(0 => 73, 1 => 2),
+                                      array(0 => 73, 1 => 3), array(0 => 73, 1 => 3), array(0 => 73, 1 => 3),
+                                      array(0 => 73, 1 => 3), array(0 => 82, 1 => 7), array(0 => 82, 1 => 7),
+                                      array(0 => 72, 1 => 1), array(0 => 72, 1 => 2), array(0 => 72, 1 => 2),
+                                      array(0 => 72, 1 => 2), array(0 => 72, 1 => 2), array(0 => 72, 1 => 1),
+                                      array(0 => 72, 1 => 1), array(0 => 72, 1 => 3), array(0 => 72, 1 => 2),
+                                      array(0 => 72, 1 => 2), array(0 => 72, 1 => 1), array(0 => 72, 1 => 1),
+                                      array(0 => 72, 1 => 3), array(0 => 72, 1 => 1), array(0 => 72, 1 => 1),
+                                      array(0 => 72, 1 => 3), array(0 => 72, 1 => 1), array(0 => 72, 1 => 2),
+                                      array(0 => 72, 1 => 1), array(0 => 72, 1 => 3), array(0 => 86, 1 => 1),
+                                      array(0 => 86, 1 => 1), array(0 => 70, 1 => 1), array(0 => 70, 1 => 1),
+                                      array(0 => 70, 1 => 3), array(0 => 70, 1 => 1), array(0 => 70, 1 => 3),
+                                      array(0 => 70, 1 => 4), array(0 => 70, 1 => 3), array(0 => 70, 1 => 4),
+                                      array(0 => 74, 1 => 2), array(0 => 74, 1 => 2), array(0 => 91, 1 => 2),
+                                      array(0 => 91, 1 => 0), array(0 => 92, 1 => 2), array(0 => 92, 1 => 2),
+                                      array(0 => 92, 1 => 4), array(0 => 92, 1 => 2), array(0 => 92, 1 => 2),
+                                      array(0 => 92, 1 => 4), array(0 => 92, 1 => 3), array(0 => 92, 1 => 5),
+                                      array(0 => 92, 1 => 3), array(0 => 92, 1 => 3), array(0 => 92, 1 => 3),
+                                      array(0 => 92, 1 => 3), array(0 => 92, 1 => 3), array(0 => 92, 1 => 3),
+                                      array(0 => 92, 1 => 2), array(0 => 79, 1 => 1), array(0 => 79, 1 => 1),
+                                      array(0 => 79, 1 => 2), array(0 => 93, 1 => 1), array(0 => 93, 1 => 1),
+                                      array(0 => 93, 1 => 3), array(0 => 90, 1 => 2), array(0 => 94, 1 => 1),
+                                      array(0 => 94, 1 => 2), array(0 => 95, 1 => 3), array(0 => 95, 1 => 3),
+                                      array(0 => 95, 1 => 5), array(0 => 95, 1 => 6), array(0 => 95, 1 => 2),
+                                      array(0 => 87, 1 => 4), array(0 => 96, 1 => 4), array(0 => 96, 1 => 4),
+                                      array(0 => 97, 1 => 3), array(0 => 97, 1 => 1), array(0 => 97, 1 => 0),
+                                      array(0 => 75, 1 => 3), array(0 => 75, 1 => 2), array(0 => 98, 1 => 3),
+                                      array(0 => 98, 1 => 2), array(0 => 80, 1 => 2), array(0 => 80, 1 => 0),
+                                      array(0 => 99, 1 => 2), array(0 => 99, 1 => 2), array(0 => 89, 1 => 1),
+                                      array(0 => 89, 1 => 2), array(0 => 89, 1 => 1), array(0 => 89, 1 => 2),
+                                      array(0 => 89, 1 => 3), array(0 => 84, 1 => 1), array(0 => 84, 1 => 1),
+                                      array(0 => 85, 1 => 1), array(0 => 83, 1 => 3), array(0 => 100, 1 => 1),
+                                      array(0 => 100, 1 => 3), array(0 => 100, 1 => 0), array(0 => 101, 1 => 3),
+                                      array(0 => 101, 1 => 3), array(0 => 101, 1 => 1), array(0 => 88, 1 => 2),
+                                      array(0 => 88, 1 => 3), array(0 => 102, 1 => 2), array(0 => 102, 1 => 1),
+                                      array(0 => 103, 1 => 3), array(0 => 103, 1 => 3), array(0 => 103, 1 => 1),
+                                      array(0 => 103, 1 => 3), array(0 => 103, 1 => 3), array(0 => 103, 1 => 1),
+                                      array(0 => 103, 1 => 1),);
 
-    public static $yyReduceMap = array(
-        0   => 0,
-        1   => 1,
-        2   => 2,
-        4   => 4,
-        5   => 5,
-        6   => 6,
-        7   => 7,
-        8   => 8,
-        9   => 9,
-        10  => 10,
-        11  => 11,
-        12  => 12,
-        13  => 13,
-        14  => 14,
-        15  => 15,
-        16  => 16,
-        17  => 17,
-        20  => 17,
-        199 => 17,
-        18  => 18,
-        72  => 18,
-        19  => 19,
-        100 => 19,
-        102 => 19,
-        103 => 19,
-        126 => 19,
-        164 => 19,
-        21  => 21,
-        22  => 21,
-        43  => 21,
-        65  => 21,
-        66  => 21,
-        73  => 21,
-        74  => 21,
-        79  => 21,
-        99  => 21,
-        104 => 21,
-        105 => 21,
-        110 => 21,
-        112 => 21,
-        113 => 21,
-        120 => 21,
-        137 => 21,
-        163 => 21,
-        165 => 21,
-        181 => 21,
-        186 => 21,
-        198 => 21,
-        23  => 23,
-        24  => 24,
-        25  => 25,
-        27  => 25,
-        26  => 26,
-        28  => 28,
-        29  => 28,
-        30  => 30,
-        31  => 31,
-        32  => 32,
-        33  => 33,
-        34  => 34,
-        35  => 35,
-        36  => 36,
-        37  => 37,
-        38  => 38,
-        40  => 38,
-        39  => 39,
-        41  => 41,
-        42  => 42,
-        44  => 44,
-        45  => 45,
-        46  => 46,
-        47  => 47,
-        49  => 47,
-        48  => 48,
-        50  => 48,
-        51  => 51,
-        52  => 52,
-        53  => 53,
-        54  => 54,
-        55  => 55,
-        56  => 56,
-        57  => 57,
-        58  => 58,
-        59  => 59,
-        68  => 59,
-        153 => 59,
-        157 => 59,
-        161 => 59,
-        162 => 59,
-        60  => 60,
-        154 => 60,
-        160 => 60,
-        61  => 61,
-        62  => 62,
-        63  => 62,
-        64  => 64,
-        67  => 67,
-        69  => 69,
-        70  => 70,
-        71  => 70,
-        75  => 75,
-        76  => 76,
-        77  => 76,
-        78  => 76,
-        80  => 80,
-        117 => 80,
-        81  => 81,
-        84  => 81,
-        95  => 81,
-        82  => 82,
-        83  => 83,
-        85  => 85,
-        86  => 86,
-        87  => 87,
-        92  => 87,
-        88  => 88,
-        91  => 88,
-        89  => 89,
-        94  => 89,
-        90  => 90,
-        93  => 90,
-        96  => 96,
-        97  => 97,
-        98  => 98,
-        101 => 101,
-        106 => 106,
-        107 => 107,
-        108 => 108,
-        109 => 109,
-        111 => 111,
-        114 => 114,
-        115 => 115,
-        116 => 116,
-        118 => 118,
-        119 => 119,
-        121 => 121,
-        122 => 122,
-        123 => 123,
-        124 => 124,
-        125 => 125,
-        127 => 127,
-        183 => 127,
-        128 => 128,
-        129 => 129,
-        130 => 130,
-        131 => 131,
-        132 => 132,
-        135 => 132,
-        133 => 133,
-        134 => 134,
-        136 => 136,
-        138 => 138,
-        139 => 139,
-        140 => 140,
-        141 => 141,
-        142 => 142,
-        143 => 143,
-        144 => 144,
-        145 => 145,
-        146 => 146,
-        147 => 147,
-        148 => 148,
-        149 => 149,
-        150 => 150,
-        151 => 151,
-        152 => 152,
-        155 => 155,
-        156 => 156,
-        158 => 158,
-        159 => 159,
-        166 => 166,
-        167 => 167,
-        168 => 168,
-        169 => 169,
-        170 => 170,
-        171 => 171,
-        172 => 172,
-        173 => 173,
-        174 => 174,
-        175 => 175,
-        176 => 176,
-        177 => 177,
-        178 => 178,
-        179 => 179,
-        180 => 180,
-        182 => 182,
-        184 => 184,
-        185 => 185,
-        187 => 187,
-        188 => 188,
-        189 => 189,
-        190 => 190,
-        191 => 191,
-        192 => 191,
-        194 => 191,
-        193 => 193,
-        195 => 195,
-        196 => 196,
-        197 => 197,
-    );
+    public static $yyReduceMap = array(0   => 0, 1 => 1, 2 => 2, 4 => 4, 5 => 5, 6 => 6, 7 => 7, 8 => 8, 9 => 9,
+                                       17  => 9, 18 => 9, 43 => 9, 66 => 9, 67 => 9, 75 => 9, 76 => 9, 80 => 9, 90 => 9,
+                                       95  => 9, 96 => 9, 101 => 9, 103 => 9, 104 => 9, 108 => 9, 110 => 9, 115 => 9,
+                                       176 => 9, 181 => 9, 10 => 10, 11 => 11, 12 => 12, 13 => 13, 16 => 13, 14 => 14,
+                                       74  => 14, 15 => 15, 91 => 15, 93 => 15, 94 => 15, 122 => 15, 19 => 19, 20 => 20,
+                                       21  => 21, 23 => 21, 25 => 21, 22 => 22, 24 => 22, 26 => 22, 27 => 27, 28 => 27,
+                                       29  => 29, 30 => 30, 31 => 31, 32 => 32, 33 => 33, 34 => 34, 35 => 35, 36 => 36,
+                                       37  => 37, 38 => 38, 40 => 38, 39 => 39, 41 => 41, 42 => 42, 44 => 44, 45 => 45,
+                                       46  => 46, 47 => 47, 49 => 47, 48 => 48, 50 => 48, 51 => 51, 52 => 52, 53 => 53,
+                                       54  => 54, 55 => 55, 56 => 56, 57 => 57, 58 => 58, 59 => 59, 60 => 60, 69 => 60,
+                                       157 => 60, 161 => 60, 165 => 60, 166 => 60, 61 => 61, 158 => 61, 164 => 61,
+                                       62  => 62, 63 => 63, 64 => 63, 65 => 65, 142 => 65, 68 => 68, 70 => 70, 71 => 71,
+                                       72  => 71, 73 => 73, 77 => 77, 78 => 78, 79 => 78, 81 => 81, 107 => 81, 82 => 82,
+                                       83  => 83, 84 => 84, 85 => 85, 86 => 86, 87 => 86, 88 => 88, 89 => 89, 92 => 92,
+                                       97  => 97, 98 => 98, 99 => 99, 100 => 100, 102 => 102, 105 => 105, 106 => 106,
+                                       109 => 109, 111 => 111, 112 => 112, 113 => 113, 114 => 114, 116 => 116,
+                                       117 => 117, 118 => 118, 119 => 119, 120 => 120, 121 => 121, 123 => 123,
+                                       178 => 123, 124 => 124, 125 => 125, 126 => 126, 127 => 127, 128 => 128,
+                                       129 => 129, 137 => 129, 130 => 130, 131 => 131, 132 => 132, 133 => 132,
+                                       135 => 132, 136 => 132, 134 => 134, 138 => 138, 139 => 139, 140 => 140,
+                                       182 => 140, 141 => 141, 143 => 143, 144 => 144, 145 => 145, 146 => 146,
+                                       147 => 147, 148 => 148, 149 => 149, 150 => 150, 151 => 151, 152 => 152,
+                                       153 => 153, 154 => 154, 155 => 155, 156 => 156, 159 => 159, 160 => 160,
+                                       162 => 162, 163 => 163, 167 => 167, 168 => 168, 169 => 169, 170 => 170,
+                                       171 => 171, 172 => 172, 173 => 173, 174 => 174, 175 => 175, 177 => 177,
+                                       179 => 179, 180 => 180, 183 => 183, 184 => 184, 185 => 185, 186 => 186,
+                                       187 => 186, 189 => 186, 188 => 188, 190 => 190, 191 => 191, 192 => 192,);
 
-    #line 93 "smarty_internal_templateparser.y"
+    #line 225 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r0()
     {
-        $this->_retvalue = $this->root_buffer->to_smarty_php();
+        $this->root_buffer->prepend_array($this, $this->template_prefix);
+        $this->root_buffer->append_array($this, $this->template_postfix);
+        $this->_retvalue = $this->root_buffer->to_smarty_php($this);
     }
-    #line 2150 "smarty_internal_templateparser.php"
-    #line 101 "smarty_internal_templateparser.y"
+
+    #line 235 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r1()
     {
-        if ($this->yystack[$this->yyidx + 0]->minor != null) {
+        if ($this->yystack[ $this->yyidx + 0 ]->minor != null) {
-            $this->current_buffer->append_subtree($this->yystack[$this->yyidx + 0]->minor);
+            $this->current_buffer->append_subtree($this, $this->yystack[ $this->yyidx + 0 ]->minor);
         }
     }
-    #line 2157 "smarty_internal_templateparser.php"
-    #line 108 "smarty_internal_templateparser.y"
+
+    #line 242 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r2()
     {
-        if ($this->yystack[$this->yyidx + 0]->minor != null) {
+        if ($this->yystack[ $this->yyidx + 0 ]->minor != null) {
             // because of possible code injection
-            $this->current_buffer->append_subtree($this->yystack[$this->yyidx + 0]->minor);
+            $this->current_buffer->append_subtree($this, $this->yystack[ $this->yyidx + 0 ]->minor);
         }
     }
-    #line 2165 "smarty_internal_templateparser.php"
-    #line 122 "smarty_internal_templateparser.y"
+
+    #line 256 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r4()
     {
         if ($this->compiler->has_code) {
-            $tmp = '';
-            foreach ($this->compiler->prefix_code as $code) {
-                $tmp .= $code;
-            }
-            $this->compiler->prefix_code = array();
-            $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode($tmp . $this->yystack[$this->yyidx + - 1]->minor, true));
+            $this->_retvalue = $this->mergePrefixCode($this->yystack[ $this->yyidx + 0 ]->minor);
         } else {
             $this->_retvalue = null;
         }
         $this->compiler->has_variable_string = false;
         $this->block_nesting_level = count($this->compiler->_tag_stack);
     }
-    #line 2177 "smarty_internal_templateparser.php"
-    #line 134 "smarty_internal_templateparser.y"
+
+    #line 267 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r5()
     {
-        $this->_retvalue = null;
+        $this->_retvalue = new Smarty_Internal_ParseTree_Text($this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2182 "smarty_internal_templateparser.php"
-    #line 139 "smarty_internal_templateparser.y"
+
+    #line 271 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r6()
     {
-        $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
+        $code = $this->compiler->compileTag('private_php',
+                                            array(array('code' => $this->yystack[ $this->yyidx + 0 ]->minor),
+                                                  array('type' => $this->lex->phpType)), array());
+        if ($this->compiler->has_code && !empty($code)) {
+            $tmp = '';
+            foreach ($this->compiler->prefix_code as $code) {
+                $tmp .= $code;
-    }
+            }
-    #line 2187 "smarty_internal_templateparser.php"
-    #line 144 "smarty_internal_templateparser.y"
-    function yy_r7()
-    {
-        if (strpos($this->yystack[$this->yyidx + 0]->minor, '<s') === 0) {
-            $this->lex->is_phpScript = true;
-        }
-        if ($this->php_handling == Smarty::PHP_PASSTHRU) {
-            if ($this->lex->is_phpScript) {
-                $s = addcslashes($this->yystack[$this->yyidx + 0]->minor, "'");
-                $this->_retvalue = new _smarty_text($this, $s);
+            $this->compiler->prefix_code = array();
+            $this->_retvalue =
+                new Smarty_Internal_ParseTree_Tag($this, $this->compiler->processNocacheCode($tmp . $code, true));
-            } else {
+        } else {
-                $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
-            }
-        } elseif ($this->php_handling == Smarty::PHP_QUOTE) {
-            $this->_retvalue = new _smarty_text($this, htmlspecialchars($this->yystack[$this->yyidx + 0]->minor, ENT_QUOTES));
-        } elseif ($this->php_handling == Smarty::PHP_ALLOW) {
-            if (!($this->smarty instanceof SmartyBC)) {
-                $this->compiler->trigger_template_error(self::Err3);
-            }
-            $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode('<?php ', true));
-        } elseif ($this->php_handling == Smarty::PHP_REMOVE) {
             $this->_retvalue = null;
         }
     }
-    #line 2211 "smarty_internal_templateparser.php"
-    #line 168 "smarty_internal_templateparser.y"
-    function yy_r8()
+
+    #line 282 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r7()
     {
-        if ($this->is_xml) {
-            $this->compiler->tag_nocache = true;
+        $this->compiler->tag_nocache = true;
-            $this->is_xml = false;
-            $save = $this->template->has_nocache_code;
-            $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode("<?php echo '?>';?>\n", $this->compiler, true));
-            $this->template->has_nocache_code = $save;
-        } elseif ($this->php_handling == Smarty::PHP_PASSTHRU) {
-            $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
-        } elseif ($this->php_handling == Smarty::PHP_QUOTE) {
-            $this->_retvalue = new _smarty_text($this, htmlspecialchars('?>', ENT_QUOTES));
-        } elseif ($this->php_handling == Smarty::PHP_ALLOW) {
-            $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode('?>', true));
-        } elseif ($this->php_handling == Smarty::PHP_REMOVE) {
-            $this->_retvalue = null;
+        $save = $this->template->compiled->has_nocache_code;
+        $this->_retvalue = new Smarty_Internal_ParseTree_Tag($this,
+                                                             $this->compiler->processNocacheCode("<?php echo '{$this->yystack[$this->yyidx + 0]->minor}';?>\n",
+                                                                                                 $this->compiler,
+                                                                                                 true));
+        $this->template->compiled->has_nocache_code = $save;
-        }
+    }
+
+    #line 289 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r8()
+    {
+        $this->_retvalue = $this->compiler->processText($this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2230 "smarty_internal_templateparser.php"
-    #line 186 "smarty_internal_templateparser.y"
+
+    #line 293 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r9()
     {
-        if (!$this->lex->is_phpScript) {
-            $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
-        } else {
-            $this->lex->is_phpScript = false;
-            if ($this->php_handling == Smarty::PHP_PASSTHRU) {
-                $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
-            } elseif ($this->php_handling == Smarty::PHP_QUOTE) {
-                $this->_retvalue = new _smarty_text($this, htmlspecialchars($this->yystack[$this->yyidx + 0]->minor, ENT_QUOTES));
-            } elseif ($this->php_handling == Smarty::PHP_ALLOW) {
-                $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode('?>', true));
-            } elseif ($this->php_handling == Smarty::PHP_REMOVE) {
-                $this->_retvalue = null;
+        $this->_retvalue = $this->yystack[ $this->yyidx + 0 ]->minor;
-            }
+    }
-        }
-    }
-    #line 2248 "smarty_internal_templateparser.php"
-    #line 204 "smarty_internal_templateparser.y"
+
+    #line 297 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r10()
     {
-        if ($this->php_handling == Smarty::PHP_PASSTHRU) {
-            $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
-        } elseif ($this->php_handling == Smarty::PHP_QUOTE) {
-            $this->_retvalue = new _smarty_text($this, htmlspecialchars($this->yystack[$this->yyidx + 0]->minor, ENT_QUOTES));
-        } elseif ($this->php_handling == Smarty::PHP_ALLOW) {
-            if ($this->asp_tags) {
-                if (!($this->smarty instanceof SmartyBC)) {
-                    $this->compiler->trigger_template_error(self::Err3);
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor . $this->yystack[ $this->yyidx + 0 ]->minor;
-                }
+    }
-                $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode('<%', true));
-            } else {
-                $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
-            }
-        } elseif ($this->php_handling == Smarty::PHP_REMOVE) {
-            if ($this->asp_tags) {
-                $this->_retvalue = null;
-            } else {
-                $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
-            }
-        }
-    }
-    #line 2272 "smarty_internal_templateparser.php"
-    #line 228 "smarty_internal_templateparser.y"
+
+    #line 302 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r11()
     {
-        if ($this->php_handling == Smarty::PHP_PASSTHRU) {
-            $this->_retvalue = new _smarty_text($this, st);
-        } elseif ($this->php_handling == Smarty::PHP_QUOTE) {
-            $this->_retvalue = new _smarty_text($this, htmlspecialchars('%>', ENT_QUOTES));
-        } elseif ($this->php_handling == Smarty::PHP_ALLOW) {
-            if ($this->asp_tags) {
-                $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode('%>', true));
-            } else {
-                $this->_retvalue = new _smarty_text($this, st);
+        $this->strip = true;
-            }
+    }
-        } elseif ($this->php_handling == Smarty::PHP_REMOVE) {
-            if ($this->asp_tags) {
-                $this->_retvalue = null;
-            } else {
-                $this->_retvalue = new _smarty_text($this, st);
-            }
-        }
-    }
-    #line 2293 "smarty_internal_templateparser.php"
-    #line 250 "smarty_internal_templateparser.y"
+
+    #line 306 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r12()
     {
-        $this->compiler->tag_nocache = true;
-        $this->is_xml = true;
-        $save = $this->template->has_nocache_code;
-        $this->_retvalue = new _smarty_tag($this, $this->compiler->processNocacheCode("<?php echo '<?xml';?>", $this->compiler, true));
-        $this->template->has_nocache_code = $save;
+        $this->strip = false;
     }
-    #line 2302 "smarty_internal_templateparser.php"
-    #line 259 "smarty_internal_templateparser.y"
+
+    #line 311 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r13()
     {
-        if ($this->strip) {
-            $this->_retvalue = new _smarty_text($this, preg_replace('![\t ]*[\r\n]+[\t ]*!', '', $this->yystack[$this->yyidx + 0]->minor));
-        } else {
-            $this->_retvalue = new _smarty_text($this, $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue = '';
-        }
+    }
-    }
-    #line 2311 "smarty_internal_templateparser.php"
-    #line 268 "smarty_internal_templateparser.y"
+
+    #line 315 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r14()
     {
-        $this->strip = true;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor;
     }
-    #line 2316 "smarty_internal_templateparser.php"
-    #line 272 "smarty_internal_templateparser.y"
+
+    #line 319 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r15()
     {
-        $this->strip = false;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2321 "smarty_internal_templateparser.php"
-    #line 276 "smarty_internal_templateparser.y"
-    function yy_r16()
+
+    #line 335 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r19()
     {
-        if ($this->strip) {
-            SMARTY_INTERNAL_COMPILE_BLOCK::blockSource($this->compiler, preg_replace('![\t ]*[\r\n]+[\t ]*!', '', $this->yystack[$this->yyidx + 0]->minor));
-        } else {
-            SMARTY_INTERNAL_COMPILE_BLOCK::blockSource($this->compiler, $this->yystack[$this->yyidx + 0]->minor);
-        }
-    }
-    #line 2330 "smarty_internal_templateparser.php"
-    #line 285 "smarty_internal_templateparser.y"
-    function yy_r17()
-    {
-        $this->_retvalue = '';
-    }
-    #line 2335 "smarty_internal_templateparser.php"
-    #line 289 "smarty_internal_templateparser.y"
-    function yy_r18()
-    {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor;
     }
-    #line 2340 "smarty_internal_templateparser.php"
-    #line 293 "smarty_internal_templateparser.y"
-    function yy_r19()
+
+    #line 341 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r20()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor . $this->yystack[$this->yyidx + 0]->minor;
+        $var =
+            trim(substr($this->yystack[ $this->yyidx + 0 ]->minor, $this->lex->ldel_length, - $this->lex->rdel_length),
+                 ' $');
+        if (preg_match('/^(.*)(\s+nocache)$/', $var, $match)) {
+            $this->_retvalue = $this->compiler->compileTag('private_print_expression', array('nocache'),
+                                                           array('value' => $this->compiler->compileVariable('\'' .
+                                                                                                             $match[ 1 ] .
+                                                                                                             '\'')));
+        } else {
+            $this->_retvalue = $this->compiler->compileTag('private_print_expression', array(),
+                                                           array('value' => $this->compiler->compileVariable('\'' .
+                                                                                                             $var .
+                                                                                                             '\'')));
-    }
+        }
-    #line 2345 "smarty_internal_templateparser.php"
-    #line 301 "smarty_internal_templateparser.y"
+    }
+
+    #line 351 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r21()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = $this->compiler->compileTag('private_print_expression', array(),
+                                                       array('value' => $this->yystack[ $this->yyidx + 0 ]->minor));
     }
-    #line 2350 "smarty_internal_templateparser.php"
-    #line 314 "smarty_internal_templateparser.y"
-    function yy_r23()
+
+    #line 355 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r22()
     {
-        $this->_retvalue = $this->compiler->compileTag('private_print_expression', array(), array('value' => $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue =
+            $this->compiler->compileTag('private_print_expression', $this->yystack[ $this->yyidx + 0 ]->minor,
+                                        array('value' => $this->yystack[ $this->yyidx + - 1 ]->minor));
     }
-    #line 2355 "smarty_internal_templateparser.php"
-    #line 318 "smarty_internal_templateparser.y"
-    function yy_r24()
+
+    #line 378 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r27()
     {
-        $this->_retvalue = $this->compiler->compileTag('private_print_expression', $this->yystack[$this->yyidx + 0]->minor, array('value' => $this->yystack[$this->yyidx + - 2]->minor, 'modifierlist' => $this->yystack[$this->yyidx + - 1]->minor));
+        $this->_retvalue = $this->compiler->compileTag('assign', array(array('value' => $this->yystack[ $this->yyidx +
+        0 ]->minor), array('var' => '\'' . substr($this->yystack[ $this->yyidx + - 2 ]->minor, 1) . '\'')));
     }
-    #line 2360 "smarty_internal_templateparser.php"
-    #line 322 "smarty_internal_templateparser.y"
-    function yy_r25()
+
+    #line 386 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r29()
     {
-        $this->_retvalue = $this->compiler->compileTag('private_print_expression', $this->yystack[$this->yyidx + 0]->minor, array('value' => $this->yystack[$this->yyidx + - 1]->minor));
+        $this->_retvalue = $this->compiler->compileTag('assign',
+                                                       array_merge(array(array('value' => $this->yystack[ $this->yyidx +
+                                                       - 1 ]->minor), array('var' => '\'' .
+                                                           substr($this->yystack[ $this->yyidx + - 3 ]->minor, 1) .
+                                                           '\'')), $this->yystack[ $this->yyidx + 0 ]->minor));
     }
-    #line 2365 "smarty_internal_templateparser.php"
-    #line 326 "smarty_internal_templateparser.y"
-    function yy_r26()
-    {
-        $this->_retvalue = $this->compiler->compileTag('private_print_expression', $this->yystack[$this->yyidx + 0]->minor, array('value' => $this->yystack[$this->yyidx + - 2]->minor, 'modifierlist' => $this->yystack[$this->yyidx + - 1]->minor));
-    }
-    #line 2370 "smarty_internal_templateparser.php"
-    #line 339 "smarty_internal_templateparser.y"
-    function yy_r28()
-    {
-        $this->_retvalue = $this->compiler->compileTag('assign', array(array('value' => $this->yystack[$this->yyidx + 0]->minor), array('var' => "'" . $this->yystack[$this->yyidx + - 2]->minor . "'")));
-    }
-    #line 2375 "smarty_internal_templateparser.php"
-    #line 347 "smarty_internal_templateparser.y"
+
+    #line 390 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r30()
     {
-        $this->_retvalue = $this->compiler->compileTag('assign', array_merge(array(array('value' => $this->yystack[$this->yyidx + - 1]->minor), array('var' => "'" . $this->yystack[$this->yyidx + - 3]->minor . "'")), $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue = $this->compiler->compileTag('assign',
+                                                       array_merge(array(array('value' => $this->yystack[ $this->yyidx +
+                                                       - 1 ]->minor), array('var' => $this->yystack[ $this->yyidx +
+                                                       - 3 ]->minor[ 'var' ])),
+                                                                   $this->yystack[ $this->yyidx + 0 ]->minor),
+                                                       array('smarty_internal_index' => $this->yystack[ $this->yyidx +
+                                                       - 3 ]->minor[ 'smarty_internal_index' ]));
     }
-    #line 2380 "smarty_internal_templateparser.php"
-    #line 351 "smarty_internal_templateparser.y"
+
+    #line 395 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r31()
     {
-        $this->_retvalue = $this->compiler->compileTag('assign', array_merge(array(array('value' => $this->yystack[$this->yyidx + - 1]->minor), array('var' => $this->yystack[$this->yyidx + - 3]->minor['var'])), $this->yystack[$this->yyidx + 0]->minor), array('smarty_internal_index' => $this->yystack[$this->yyidx + - 3]->minor['smarty_internal_index']));
+        $tag =
+            trim(substr($this->yystack[ $this->yyidx + 0 ]->minor, $this->lex->ldel_length, - $this->lex->rdel_length));
+        if ($tag == 'strip') {
+            $this->strip = true;
+            $this->_retvalue = null;;
+        } else {
+            if (defined($tag)) {
+                if ($this->security) {
+                    $this->security->isTrustedConstant($tag, $this->compiler);
-    }
+                }
-    #line 2385 "smarty_internal_templateparser.php"
-    #line 356 "smarty_internal_templateparser.y"
+                $this->_retvalue =
+                    $this->compiler->compileTag('private_print_expression', array(), array('value' => $tag));
+            } else {
+                if (preg_match('/^(.*)(\s+nocache)$/', $tag, $match)) {
+                    $this->_retvalue = $this->compiler->compileTag($match[ 1 ], array("'nocache'"));
+                } else {
+                    $this->_retvalue = $this->compiler->compileTag($tag, array());
+                }
+            }
+        }
+    }
+
+    #line 417 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r32()
     {
-        $this->_retvalue = $this->compiler->compileTag($this->yystack[$this->yyidx + - 1]->minor, $this->yystack[$this->yyidx + 0]->minor);
+        if (defined($this->yystack[ $this->yyidx + - 1 ]->minor)) {
+            if ($this->security) {
+                $this->security->isTrustedConstant($this->yystack[ $this->yyidx + - 1 ]->minor, $this->compiler);
-    }
+            }
-    #line 2390 "smarty_internal_templateparser.php"
-    #line 360 "smarty_internal_templateparser.y"
+            $this->_retvalue =
+                $this->compiler->compileTag('private_print_expression', $this->yystack[ $this->yyidx + 0 ]->minor,
+                                            array('value' => $this->yystack[ $this->yyidx + - 1 ]->minor));
+        } else {
+            $this->_retvalue = $this->compiler->compileTag($this->yystack[ $this->yyidx + - 1 ]->minor,
+                                                           $this->yystack[ $this->yyidx + 0 ]->minor);
+        }
+    }
+
+    #line 427 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r33()
     {
+        if (defined($this->yystack[ $this->yyidx + 0 ]->minor)) {
+            if ($this->security) {
+                $this->security->isTrustedConstant($this->yystack[ $this->yyidx + 0 ]->minor, $this->compiler);
+            }
+            $this->_retvalue = $this->compiler->compileTag('private_print_expression', array(),
+                                                           array('value' => $this->yystack[ $this->yyidx + 0 ]->minor));
+        } else {
-        $this->_retvalue = $this->compiler->compileTag($this->yystack[$this->yyidx + 0]->minor, array());
+            $this->_retvalue = $this->compiler->compileTag($this->yystack[ $this->yyidx + 0 ]->minor, array());
-    }
+        }
-    #line 2395 "smarty_internal_templateparser.php"
-    #line 365 "smarty_internal_templateparser.y"
+    }
+
+    #line 440 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r34()
     {
-        $this->_retvalue = $this->compiler->compileTag($this->yystack[$this->yyidx + - 3]->minor, $this->yystack[$this->yyidx + 0]->minor, array('object_method' => $this->yystack[$this->yyidx + - 1]->minor));
+        if (defined($this->yystack[ $this->yyidx + - 2 ]->minor)) {
+            if ($this->security) {
+                $this->security->isTrustedConstant($this->yystack[ $this->yyidx + - 2 ]->minor, $this->compiler);
-    }
+            }
-    #line 2400 "smarty_internal_templateparser.php"
-    #line 370 "smarty_internal_templateparser.y"
+            $this->_retvalue =
+                $this->compiler->compileTag('private_print_expression', $this->yystack[ $this->yyidx + 0 ]->minor,
+                                            array('value'        => $this->yystack[ $this->yyidx + - 2 ]->minor,
+                                                  'modifierlist' => $this->yystack[ $this->yyidx + - 1 ]->minor));
+        } else {
+            $this->_retvalue = '<?php ob_start();?>' .
+                $this->compiler->compileTag($this->yystack[ $this->yyidx + - 2 ]->minor,
+                                            $this->yystack[ $this->yyidx + 0 ]->minor) . '<?php echo ';
+            $this->_retvalue .= $this->compiler->compileTag('private_modifier', array(),
+                                                            array('modifierlist'  => $this->yystack[ $this->yyidx +
+                                                            - 1 ]->minor, 'value' => 'ob_get_clean()')) . ';?>';
+        }
+    }
+
+    #line 453 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r35()
     {
-        $this->_retvalue = '<?php ob_start();?>' . $this->compiler->compileTag($this->yystack[$this->yyidx + - 2]->minor, $this->yystack[$this->yyidx + 0]->minor) . '<?php echo ';
-        $this->_retvalue .= $this->compiler->compileTag('private_modifier', array(), array('modifierlist' => $this->yystack[$this->yyidx + - 1]->minor, 'value' => 'ob_get_clean()')) . '?>';
+        $this->_retvalue = $this->compiler->compileTag($this->yystack[ $this->yyidx + - 3 ]->minor,
+                                                       $this->yystack[ $this->yyidx + 0 ]->minor,
+                                                       array('object_method' => $this->yystack[ $this->yyidx +
+                                                       - 1 ]->minor));
     }
-    #line 2406 "smarty_internal_templateparser.php"
-    #line 376 "smarty_internal_templateparser.y"
+
+    #line 458 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r36()
     {
-        $this->_retvalue = '<?php ob_start();?>' . $this->compiler->compileTag($this->yystack[$this->yyidx + - 4]->minor, $this->yystack[$this->yyidx + 0]->minor, array('object_method' => $this->yystack[$this->yyidx + - 2]->minor)) . '<?php echo ';
-        $this->_retvalue .= $this->compiler->compileTag('private_modifier', array(), array('modifierlist' => $this->yystack[$this->yyidx + - 1]->minor, 'value' => 'ob_get_clean()')) . '?>';
+        $this->_retvalue = '<?php ob_start();?>' .
+            $this->compiler->compileTag($this->yystack[ $this->yyidx + - 4 ]->minor,
+                                        $this->yystack[ $this->yyidx + 0 ]->minor,
+                                        array('object_method' => $this->yystack[ $this->yyidx + - 2 ]->minor)) .
+            '<?php echo ';
+        $this->_retvalue .= $this->compiler->compileTag('private_modifier', array(),
+                                                        array('modifierlist'  => $this->yystack[ $this->yyidx +
+                                                        - 1 ]->minor, 'value' => 'ob_get_clean()')) . ';?>';
     }
-    #line 2412 "smarty_internal_templateparser.php"
-    #line 382 "smarty_internal_templateparser.y"
+
+    #line 464 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r37()
     {
-        $tag = trim(substr($this->yystack[$this->yyidx + - 1]->minor, $this->lex->ldel_length));
+        $tag = trim(substr($this->yystack[ $this->yyidx + - 1 ]->minor, $this->lex->ldel_length));
-        $this->_retvalue = $this->compiler->compileTag(($tag == 'else if') ? 'elseif' : $tag, array(), array('if condition' => $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue = $this->compiler->compileTag(($tag == 'else if') ? 'elseif' : $tag, array(),
+                                                       array('if condition' => $this->yystack[ $this->yyidx +
+                                                       0 ]->minor));
     }
-    #line 2418 "smarty_internal_templateparser.php"
-    #line 387 "smarty_internal_templateparser.y"
+
+    #line 469 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r38()
     {
-        $tag = trim(substr($this->yystack[$this->yyidx + - 2]->minor, $this->lex->ldel_length));
+        $tag = trim(substr($this->yystack[ $this->yyidx + - 2 ]->minor, $this->lex->ldel_length));
-        $this->_retvalue = $this->compiler->compileTag(($tag == 'else if') ? 'elseif' : $tag, $this->yystack[$this->yyidx + 0]->minor, array('if condition' => $this->yystack[$this->yyidx + - 1]->minor));
+        $this->_retvalue = $this->compiler->compileTag(($tag == 'else if') ? 'elseif' : $tag,
+                                                       $this->yystack[ $this->yyidx + 0 ]->minor,
+                                                       array('if condition' => $this->yystack[ $this->yyidx +
+                                                       - 1 ]->minor));
     }
-    #line 2424 "smarty_internal_templateparser.php"
-    #line 392 "smarty_internal_templateparser.y"
+
+    #line 474 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r39()
     {
-        $tag = trim(substr($this->yystack[$this->yyidx + - 1]->minor, $this->lex->ldel_length));
+        $tag = trim(substr($this->yystack[ $this->yyidx + - 1 ]->minor, $this->lex->ldel_length));
-        $this->_retvalue = $this->compiler->compileTag(($tag == 'else if') ? 'elseif' : $tag, array(), array('if condition' => $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue = $this->compiler->compileTag(($tag == 'else if') ? 'elseif' : $tag, array(),
+                                                       array('if condition' => $this->yystack[ $this->yyidx +
+                                                       0 ]->minor));
     }
-    #line 2430 "smarty_internal_templateparser.php"
-    #line 403 "smarty_internal_templateparser.y"
+
+    #line 485 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r41()
     {
-        $this->_retvalue = $this->compiler->compileTag('for', array_merge($this->yystack[$this->yyidx + 0]->minor, array(array('start' => $this->yystack[$this->yyidx + - 9]->minor), array('ifexp' => $this->yystack[$this->yyidx + - 6]->minor), array('var' => $this->yystack[$this->yyidx + - 2]->minor), array('step' => $this->yystack[$this->yyidx + - 1]->minor))), 1);
+        $this->_retvalue = $this->compiler->compileTag('for', array_merge($this->yystack[ $this->yyidx + 0 ]->minor,
+                                                                          array(array('start' => $this->yystack[ $this->yyidx +
+                                                                          - 6 ]->minor),
+                                                                                array('ifexp' => $this->yystack[ $this->yyidx +
+                                                                                - 4 ]->minor),
+                                                                                array('var' => $this->yystack[ $this->yyidx +
+                                                                                - 2 ]->minor),
+                                                                                array('step' => $this->yystack[ $this->yyidx +
+                                                                                - 1 ]->minor))), 1);
     }
-    #line 2435 "smarty_internal_templateparser.php"
-    #line 407 "smarty_internal_templateparser.y"
+
+    #line 489 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r42()
     {
-        $this->_retvalue = '=' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = '=' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2440 "smarty_internal_templateparser.php"
-    #line 415 "smarty_internal_templateparser.y"
+
+    #line 497 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r44()
     {
-        $this->_retvalue = $this->compiler->compileTag('for', array_merge($this->yystack[$this->yyidx + 0]->minor, array(array('start' => $this->yystack[$this->yyidx + - 3]->minor), array('to' => $this->yystack[$this->yyidx + - 1]->minor))), 0);
+        $this->_retvalue = $this->compiler->compileTag('for', array_merge($this->yystack[ $this->yyidx + 0 ]->minor,
+                                                                          array(array('start' => $this->yystack[ $this->yyidx +
+                                                                          - 3 ]->minor),
+                                                                                array('to' => $this->yystack[ $this->yyidx +
+                                                                                - 1 ]->minor))), 0);
     }
-    #line 2445 "smarty_internal_templateparser.php"
-    #line 419 "smarty_internal_templateparser.y"
+
+    #line 501 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r45()
     {
-        $this->_retvalue = $this->compiler->compileTag('for', array_merge($this->yystack[$this->yyidx + 0]->minor, array(array('start' => $this->yystack[$this->yyidx + - 5]->minor), array('to' => $this->yystack[$this->yyidx + - 3]->minor), array('step' => $this->yystack[$this->yyidx + - 1]->minor))), 0);
+        $this->_retvalue = $this->compiler->compileTag('for', array_merge($this->yystack[ $this->yyidx + 0 ]->minor,
+                                                                          array(array('start' => $this->yystack[ $this->yyidx +
+                                                                          - 5 ]->minor),
+                                                                                array('to' => $this->yystack[ $this->yyidx +
+                                                                                - 3 ]->minor),
+                                                                                array('step' => $this->yystack[ $this->yyidx +
+                                                                                - 1 ]->minor))), 0);
     }
-    #line 2450 "smarty_internal_templateparser.php"
-    #line 424 "smarty_internal_templateparser.y"
+
+    #line 506 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r46()
     {
-        $this->_retvalue = $this->compiler->compileTag('foreach', $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue = $this->compiler->compileTag('foreach', $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2455 "smarty_internal_templateparser.php"
-    #line 429 "smarty_internal_templateparser.y"
+
+    #line 511 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r47()
     {
-        $this->_retvalue = $this->compiler->compileTag('foreach', array_merge($this->yystack[$this->yyidx + 0]->minor, array(array('from' => $this->yystack[$this->yyidx + - 4]->minor), array('item' => $this->yystack[$this->yyidx + - 1]->minor))));
+        $this->_retvalue = $this->compiler->compileTag('foreach', array_merge($this->yystack[ $this->yyidx + 0 ]->minor,
+                                                                              array(array('from' => $this->yystack[ $this->yyidx +
+                                                                              - 3 ]->minor),
+                                                                                    array('item' => $this->yystack[ $this->yyidx +
+                                                                                    - 1 ]->minor))));
     }
-    #line 2460 "smarty_internal_templateparser.php"
-    #line 433 "smarty_internal_templateparser.y"
+
+    #line 515 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r48()
     {
-        $this->_retvalue = $this->compiler->compileTag('foreach', array_merge($this->yystack[$this->yyidx + 0]->minor, array(array('from' => $this->yystack[$this->yyidx + - 7]->minor), array('item' => $this->yystack[$this->yyidx + - 1]->minor), array('key' => $this->yystack[$this->yyidx + - 4]->minor))));
+        $this->_retvalue = $this->compiler->compileTag('foreach', array_merge($this->yystack[ $this->yyidx + 0 ]->minor,
+                                                                              array(array('from' => $this->yystack[ $this->yyidx +
+                                                                              - 5 ]->minor),
+                                                                                    array('item' => $this->yystack[ $this->yyidx +
+                                                                                    - 1 ]->minor),
+                                                                                    array('key' => $this->yystack[ $this->yyidx +
+                                                                                    - 3 ]->minor))));
     }
-    #line 2465 "smarty_internal_templateparser.php"
-    #line 446 "smarty_internal_templateparser.y"
+
+    #line 528 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r51()
     {
-        $this->_retvalue = $this->compiler->compileTag('setfilter', array(), array('modifier_list' => array(array_merge(array($this->yystack[$this->yyidx + - 1]->minor), $this->yystack[$this->yyidx + 0]->minor))));
+        $this->_retvalue = $this->compiler->compileTag('setfilter', array(),
+                                                       array('modifier_list' => array(array_merge(array($this->yystack[ $this->yyidx +
+                                                       - 1 ]->minor), $this->yystack[ $this->yyidx + 0 ]->minor))));
     }
-    #line 2470 "smarty_internal_templateparser.php"
-    #line 450 "smarty_internal_templateparser.y"
+
+    #line 532 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r52()
     {
-        $this->_retvalue = $this->compiler->compileTag('setfilter', array(), array('modifier_list' => array_merge(array(array_merge(array($this->yystack[$this->yyidx + - 2]->minor), $this->yystack[$this->yyidx + - 1]->minor)), $this->yystack[$this->yyidx + 0]->minor)));
+        $this->_retvalue = $this->compiler->compileTag('setfilter', array(),
+                                                       array('modifier_list' => array_merge(array(array_merge(array($this->yystack[ $this->yyidx +
+                                                       - 2 ]->minor), $this->yystack[ $this->yyidx + - 1 ]->minor)),
+                                                                                            $this->yystack[ $this->yyidx +
+                                                                                            0 ]->minor)));
     }
-    #line 2475 "smarty_internal_templateparser.php"
-    #line 455 "smarty_internal_templateparser.y"
+
+    #line 537 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r53()
     {
-        $j = strrpos($this->yystack[$this->yyidx + 0]->minor, '.');
+        $j = strrpos($this->yystack[ $this->yyidx + 0 ]->minor, '.');
-        if ($this->yystack[$this->yyidx + 0]->minor[$j + 1] == 'c') {
+        if ($this->yystack[ $this->yyidx + 0 ]->minor[ $j + 1 ] == 'c') {
             // {$smarty.block.child}
             $this->_retvalue = SMARTY_INTERNAL_COMPILE_BLOCK::compileChildBlock($this->compiler);
         } else {
